--- a/ext/opcache/jit/ir/ir_cfg.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_cfg.c	2025-10-25 03:24:13.160775377 +0000
@@ -605,7 +605,7 @@
 
 /* Computes dominator tree using algorithm from "A Simple, Fast Dominance Algorithm" by
  * Cooper, Harvey and Kennedy. */
-static int ir_build_dominators_tree_slow(ir_ctx *ctx)
+static IR_NEVER_INLINE int ir_build_dominators_tree_slow(ir_ctx *ctx)
 {
 	uint32_t blocks_count, b, postnum;
 	ir_block *blocks, *bb;
@@ -690,28 +690,13 @@
 	/* Build dominators tree */
 	blocks[1].idom = 0;
 	blocks[1].dom_depth = 0;
-	for (b = 2, bb = &blocks[2]; b <= blocks_count; b++, bb++) {
-		uint32_t idom = bb->idom;
-		ir_block *idom_bb = &blocks[idom];
 
+	/* Construct children lists sorted by block number */
+	for (b = blocks_count, bb = &blocks[b]; b >= 2; b--, bb--) {
+		ir_block *idom_bb = &blocks[bb->idom];
 		bb->dom_depth = 0;
-		/* Sort by block number to traverse children in pre-order */
-		if (idom_bb->dom_child == 0) {
-			idom_bb->dom_child = b;
-		} else if (b < idom_bb->dom_child) {
-			bb->dom_next_child = idom_bb->dom_child;
-			idom_bb->dom_child = b;
-		} else {
-			int child = idom_bb->dom_child;
-			ir_block *child_bb = &blocks[child];
-
-			while (child_bb->dom_next_child > 0 && b > child_bb->dom_next_child) {
-				child = child_bb->dom_next_child;
-				child_bb = &blocks[child];
-			}
-			bb->dom_next_child = child_bb->dom_next_child;
-			child_bb->dom_next_child = b;
-		}
+		bb->dom_next_child = idom_bb->dom_child;
+		idom_bb->dom_child = b;
 	}
 
 	/* Recalculate dom_depth for all blocks */
@@ -769,6 +754,7 @@
 			ctx->flags2 &= ~IR_NO_LOOPS;
 //			IR_ASSERT(k > 1 && "Wrong blocks order: BB is before its single predecessor");
 			if (UNEXPECTED(k <= 1)) {
+slow_case:
 				ir_list_free(&worklist);
 				return ir_build_dominators_tree_slow(ctx);
 			}
@@ -780,7 +766,9 @@
 				if (idom < b) {
 					break;
 				}
-				IR_ASSERT(k > 0);
+				if (UNEXPECTED(k == 0)) {
+					goto slow_case;
+				}
 				ir_list_push(&worklist, idom);
 			}
 		}
@@ -808,25 +796,14 @@
 		}
 		bb->idom = idom;
 		idom_bb = &blocks[idom];
-
 		bb->dom_depth = idom_bb->dom_depth + 1;
-		/* Sort by block number to traverse children in pre-order */
-		if (idom_bb->dom_child == 0) {
-			idom_bb->dom_child = b;
-		} else if (b < idom_bb->dom_child) {
-			bb->dom_next_child = idom_bb->dom_child;
-			idom_bb->dom_child = b;
-		} else {
-			int child = idom_bb->dom_child;
-			ir_block *child_bb = &blocks[child];
-
-			while (child_bb->dom_next_child > 0 && b > child_bb->dom_next_child) {
-				child = child_bb->dom_next_child;
-				child_bb = &blocks[child];
-			}
-			bb->dom_next_child = child_bb->dom_next_child;
-			child_bb->dom_next_child = b;
-		}
+	}
+
+	/* Construct children lists sorted by block number */
+	for (b = blocks_count, bb = &blocks[b]; b >= 2; b--, bb--) {
+		ir_block *idom_bb = &blocks[bb->idom];
+		bb->dom_next_child = idom_bb->dom_child;
+		idom_bb->dom_child = b;
 	}
 
 	blocks[1].idom = 0;
@@ -945,23 +922,13 @@
 		ir_block *idom_bb = &blocks[idom];
 
 		bb->dom_depth = idom_bb->dom_depth + 1;
-		/* Sort by block number to traverse children in pre-order */
-		if (idom_bb->dom_child == 0) {
-			idom_bb->dom_child = b;
-		} else if (b < idom_bb->dom_child) {
-			bb->dom_next_child = idom_bb->dom_child;
-			idom_bb->dom_child = b;
-		} else {
-			int child = idom_bb->dom_child;
-			ir_block *child_bb = &blocks[child];
-
-			while (child_bb->dom_next_child > 0 && b > child_bb->dom_next_child) {
-				child = child_bb->dom_next_child;
-				child_bb = &blocks[child];
-			}
-			bb->dom_next_child = child_bb->dom_next_child;
-			child_bb->dom_next_child = b;
-		}
+	}
+
+	/* Construct children lists sorted by block number */
+	for (b = blocks_count, bb = &blocks[b]; b >= 2; b--, bb--) {
+		ir_block *idom_bb = &blocks[bb->idom];
+		bb->dom_next_child = idom_bb->dom_child;
+		idom_bb->dom_child = b;
 	}
 
 	return 1;
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_dump.c b/ext/opcache/jit/ir/ir_dump.c
--- a/ext/opcache/jit/ir/ir_dump.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_dump.c	2025-10-25 03:24:13.161034278 +0000
@@ -660,6 +660,12 @@
 			}
 			if (first) {
 				fprintf(f, ";");
+			} else if (ctx->value_params
+			 && insn->op == IR_PARAM
+			 && ctx->value_params[insn->op3 - 1].align) {
+				fprintf(f, ") ByVal(%d, %d);",
+					ctx->value_params[insn->op3 - 1].size,
+					ctx->value_params[insn->op3 - 1].align);
 			} else {
 				fprintf(f, ");");
 			}
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_emit.c b/ext/opcache/jit/ir/ir_emit.c
--- a/ext/opcache/jit/ir/ir_emit.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_emit.c	2025-10-25 03:24:13.161165479 +0000
@@ -167,11 +167,24 @@
 		if (insn->op == IR_PARAM) {
 			if (IR_IS_TYPE_INT(insn->type)) {
 				if (use == ref) {
+#if defined(IR_TARGET_X64) || defined(IR_TARGET_X86)
+					if (ctx->value_params && ctx->value_params[insn->op3 - 1].align) {
+						/* struct passed by value on stack */
+						return IR_REG_NONE;
+					} else
+#endif
 					if (int_param < int_reg_params_count) {
 						return int_reg_params[int_param];
 					} else {
 						return IR_REG_NONE;
 					}
+#if defined(IR_TARGET_X64) || defined(IR_TARGET_X86)
+				} else {
+					if (ctx->value_params && ctx->value_params[insn->op3 - 1].align) {
+						/* struct passed by value on stack */
+						continue;
+					}
+#endif
 				}
 				int_param++;
 #ifdef _WIN64
@@ -222,9 +235,12 @@
 	n = insn->inputs_count;
 	n = IR_MIN(n, IR_MAX_REG_ARGS + 2);
 	for (j = 3; j <= n; j++) {
-		type = ctx->ir_base[ir_insn_op(insn, j)].type;
+		ir_insn *arg = &ctx->ir_base[ir_insn_op(insn, j)];
+		type = arg->type;
 		if (IR_IS_TYPE_INT(type)) {
-			if (int_param < int_reg_params_count) {
+			if (arg->op == IR_ARGVAL) {
+				continue;
+			} else if (int_param < int_reg_params_count) {
 				regs[j] = int_reg_params[int_param];
 				count = j + 1;
 			} else {
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_fold.h b/ext/opcache/jit/ir/ir_fold.h
--- a/ext/opcache/jit/ir/ir_fold.h	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_fold.h	2025-10-25 03:24:13.161353902 +0000
@@ -1703,6 +1703,11 @@
 {
 	if (op2_insn->val.u64 == 0) {
 		/* a +/- 0 => a */
+		if (op1_insn->type != IR_OPT_TYPE(opt)) {
+			opt = IR_BITCAST | (opt & IR_OPT_TYPE_MASK);
+			op2 = IR_UNUSED;
+			IR_FOLD_RESTART;
+		}
 		IR_FOLD_COPY(op1);
 	}
 	IR_FOLD_NEXT;
@@ -1721,6 +1726,12 @@
 {
 	if (op1_insn->val.u64 == 0) {
 		/* 0 + a => a */
+		if (op2_insn->type != IR_OPT_TYPE(opt)) {
+			opt = IR_BITCAST | (opt & IR_OPT_TYPE_MASK);
+			op1 = op2;
+			op2 = IR_UNUSED;
+			IR_FOLD_RESTART;
+		}
 		IR_FOLD_COPY(op2);
 	}
 	IR_FOLD_NEXT;
@@ -2927,7 +2938,7 @@
 		/* c1 - (x - c2) => (c1 + c2) - x */
 		val.u64 = op1_insn->val.u64 + ctx->ir_base[op2_insn->op2].val.u64;
 		op2 = op2_insn->op1;
-		op1 = ir_const(ctx, val, op1_insn->op1);
+		op1 = ir_const(ctx, val, op1_insn->type);
 		IR_FOLD_RESTART;
 	} else if (IR_IS_CONST_REF(op2_insn->op1) && !IR_IS_SYM_CONST(ctx->ir_base[op2_insn->op1].op)) {
 		/* c1 - (c2 - x) => x + (c1 - c2) */
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_gcm.c b/ext/opcache/jit/ir/ir_gcm.c
--- a/ext/opcache/jit/ir/ir_gcm.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_gcm.c	2025-10-25 03:24:13.161592935 +0000
@@ -792,21 +792,26 @@
 	ir_ref *p = insn->ops + 1;
 
 	if (n == 1) {
-		return *p < start;
+		return ctx->cfg_map[*p] < b;
 	} else {
 		IR_ASSERT(n > 1);
 		for (; n > 0; p++, n--) {
 			ir_ref input = *p;
-			if (input < start) {
-				/* ordered */
-			} else if ((bb->flags & IR_BB_LOOP_HEADER)
-			  && (ctx->cfg_map[input] == b || ctx->cfg_blocks[ctx->cfg_map[input]].loop_header == b)) {
-				/* back-edge of reducible loop */
-			} else if ((bb->flags & IR_BB_IRREDUCIBLE_LOOP)
-			  && (ctx->cfg_blocks[ctx->cfg_map[input]].loop_header == ctx->cfg_blocks[b].loop_header)) {
-				/* closing edge of irreducible loop */
-			} else {
-				return 0;
+
+			if (!IR_IS_CONST_REF(input)) {
+				uint32_t input_b = ctx->cfg_map[input];
+
+				if (input_b < b) {
+					/* ordered */
+				} else if ((bb->flags & IR_BB_LOOP_HEADER)
+				  && (input_b == b || ctx->cfg_blocks[input_b].loop_header == b)) {
+					/* back-edge of reducible loop */
+				} else if ((bb->flags & IR_BB_IRREDUCIBLE_LOOP)
+				  && (ctx->cfg_blocks[input_b].loop_header == bb->loop_header)) {
+					/* closing edge of irreducible loop */
+				} else {
+					return 0;
+				}
 			}
 		}
 		return 1;
@@ -925,121 +930,54 @@
 	ir_ref *_xlat;
 	ir_ref *edges;
 	ir_ref prev_b_end;
-	uint32_t b, prev_b;
+	uint32_t b;
 	uint32_t *_blocks = ctx->cfg_map;
 	ir_ref *_next = ir_mem_malloc(ctx->insns_count * sizeof(ir_ref));
 	ir_ref *_prev = ir_mem_malloc(ctx->insns_count * sizeof(ir_ref));
-	ir_ref _move_down = 0;
 	ir_block *bb;
 	ir_insn *insn, *new_insn;
 	ir_use_list *lists, *use_list, *new_list;
 	bool bad_bb_order = 0;
 
+
 	/* Create a double-linked list of nodes ordered by BB, respecting BB->start and BB->end */
 	IR_ASSERT(_blocks[1] == 1);
-	prev_b = 1;
-	prev_b_end = ctx->cfg_blocks[1].end;
+
+	/* link BB boundaries */
 	_prev[1] = 0;
-	_prev[prev_b_end] = 0;
+	prev_b_end = ctx->cfg_blocks[1].end;
+	_next[1] = prev_b_end;
+	_prev[prev_b_end] = 1;
+	for (b = 2, bb = ctx->cfg_blocks + 2; b <= ctx->cfg_blocks_count; b++, bb++) {
+		_next[prev_b_end] = bb->start;
+		_prev[bb->start] = prev_b_end;
+		_next[bb->start] = bb->end;
+		_prev[bb->end] = bb->start;
+		prev_b_end = bb->end;
+		if (!ir_is_good_bb_order(ctx, b, bb, bb->start)) {
+			bad_bb_order = 1;
+		}
+	}
+	_next[prev_b_end] = 0;
+
+	/* insert intermediate BB nodes */
 	for (i = 2, j = 1; i < ctx->insns_count; i++) {
 		b = _blocks[i];
-		IR_ASSERT((int32_t)b >= 0);
-		if (b == prev_b && i <= prev_b_end) {
-			/* add to the end of the list */
-			_next[j] = i;
-			_prev[i] = j;
-			j = i;
-		} else if (b > prev_b) {
-			bb = &ctx->cfg_blocks[b];
-			if (i == bb->start) {
-				if (bb->end > bb->start) {
-					prev_b = b;
-					prev_b_end = bb->end;
-					/* add to the end of the list */
-					_next[j] = i;
-					_prev[i] = j;
-					j = i;
-				} else {
-					prev_b = 0;
-					prev_b_end = 0;
-					k = bb->end;
-					while (_blocks[_prev[k]] == b) {
-						k = _prev[k];
-					}
-					/* insert before "k" */
-					_prev[i] = _prev[k];
-					_next[i] = k;
-					_next[_prev[k]] = i;
-					_prev[k] = i;
-				}
-				if (!ir_is_good_bb_order(ctx, b, bb, i)) {
-					bad_bb_order = 1;
-				}
-			} else if (i != bb->end) {
-				/* move down late (see the following loop) */
-				_next[i] = _move_down;
-				_move_down = i;
-			} else {
-				prev_b = 0;
-				prev_b_end = 0;
-				if (bb->start > bb->end) {
-					/* add to the end of the list */
-					_next[j] = i;
-					_prev[i] = j;
-					j = i;
-				} else {
-					k = bb->start;
-					while (_blocks[_next[k]] == b) {
-						k = _next[k];
-					}
-					/* insert after "k" */
-					_next[i] = _next[k];
-					_prev[i] = k;
-					_prev[_next[k]] = i;
-					_next[k] = i;
-				}
-			}
-		} else if (b) {
-			bb = &ctx->cfg_blocks[b];
-			IR_ASSERT(i != bb->start);
-			if (i > bb->end) {
-				/* move up, insert before the end of the already scheduled BB */
-				k = bb->end;
-			} else {
-				IR_ASSERT(i > bb->start);
-				/* move up, insert at the end of the block */
-				k = ctx->cfg_blocks[b + 1].start;
-			}
-			/* insert before "k" */
-			_prev[i] = _prev[k];
-			_next[i] = k;
-			_next[_prev[k]] = i;
-			_prev[k] = i;
-		}
-	}
-	_next[j] = 0;
-
-	while (_move_down) {
-		i = _move_down;
-		_move_down = _next[i];
-		b = _blocks[i];
+		if (!b) continue;
 		bb = &ctx->cfg_blocks[b];
-		k = _next[bb->start];
-
-		if (bb->flags & (IR_BB_HAS_PHI|IR_BB_HAS_PI|IR_BB_HAS_PARAM|IR_BB_HAS_VAR)) {
-			/* insert after the start of the block and all PARAM, VAR, PI, PHI */
-			insn = &ctx->ir_base[k];
-			while (insn->op == IR_PHI || insn->op == IR_PARAM || insn->op == IR_VAR || insn->op == IR_PI) {
-				k = _next[k];
-				insn = &ctx->ir_base[k];
-			}
+		if (i != bb->start && i != bb->end) {
+			/* insert before "end" */
+			ir_ref n = bb->end;
+			ir_ref p = _prev[n];
+			_prev[i] = p;
+			_next[i] = n;
+			_next[p] = i;
+			_prev[n] = i;
 		}
+	}
 
-		/* insert before "k" */
-		_prev[i] = _prev[k];
-		_next[i] = k;
-		_next[_prev[k]] = i;
-		_prev[k] = i;
+	if (bad_bb_order) {
+		ir_fix_bb_order(ctx, _prev, _next);
 	}
 
 #ifdef IR_DEBUG
@@ -1051,10 +989,6 @@
 	}
 #endif
 
-	if (bad_bb_order) {
-		ir_fix_bb_order(ctx, _prev, _next);
-	}
-
 	_xlat = ir_mem_calloc((ctx->consts_count + ctx->insns_count), sizeof(ir_ref));
 	_xlat += ctx->consts_count;
 	_xlat[IR_TRUE] = IR_TRUE;
@@ -1168,7 +1102,11 @@
 			if (end->op == IR_IF) {
 				/* Move condition closer to IF */
 				input = end->op2;
-				if (input > 0 && _blocks[input] == b && !_xlat[input] && _prev[j] != input) {
+				if (input > 0
+				 && _blocks[input] == b
+				 && !_xlat[input]
+				 && _prev[j] != input
+				 && (!(ir_op_flags[ctx->ir_base[input].op] & IR_OP_FLAG_CONTROL) || end->op1 == input)) {
 					if (input == i) {
 						i = _next[i];
 						insn = &ctx->ir_base[i];
@@ -1188,6 +1126,7 @@
 			ir_ref n, j, *p, input;
 
 restart:
+			IR_ASSERT(_blocks[i] == b);
 			n = insn->inputs_count;
 			for (j = n, p = insn->ops + 1; j > 0; p++, j--) {
 				input = *p;
@@ -1221,6 +1160,7 @@
 			}
 			_xlat[i] = insns_count;
 			insns_count += ir_insn_inputs_to_len(n);
+			IR_ASSERT(_next[i] != IR_UNUSED);
 			i = _next[i];
 			insn = &ctx->ir_base[i];
 		}
@@ -1274,6 +1214,7 @@
 	new_ctx.insns_count = insns_count;
 	new_ctx.flags2 = ctx->flags2;
 	new_ctx.ret_type = ctx->ret_type;
+	new_ctx.value_params = ctx->value_params;
 	new_ctx.mflags = ctx->mflags;
 	new_ctx.spill_base = ctx->spill_base;
 	new_ctx.fixed_stack_red_zone = ctx->fixed_stack_red_zone;
@@ -1511,6 +1452,7 @@
 	new_ctx.cfg_edges = ctx->cfg_edges;
 	ctx->cfg_blocks = NULL;
 	ctx->cfg_edges = NULL;
+	ctx->value_params = NULL;
 	ir_code_buffer *saved_code_buffer = ctx->code_buffer;
 
 	ir_free(ctx);
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir.h b/ext/opcache/jit/ir/ir.h
--- a/ext/opcache/jit/ir/ir.h	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/opcache/jit/ir/ir.h	2025-10-25 03:24:13.159375957 +0000
@@ -310,6 +310,8 @@
 	_(PHI,          pN,   reg, def, def) /* SSA Phi function            */ \
 	_(COPY,         d1X1, def, opt, ___) /* COPY (last foldable op)     */ \
 	_(PI,           p2,   reg, def, ___) /* e-SSA Pi constraint ???     */ \
+	_(ARGVAL,       d1X2, def, num, num) /* pass struct arg by value    */ \
+	                                     /* (op2 - size, op3 - align)   */ \
 	/* (USE, RENAME)                                                    */ \
 	\
 	/* data ops                                                         */ \
@@ -343,7 +345,8 @@
 	_(VA_START,     x2,   src, def, ___) /* va_start(va_list)           */ \
 	_(VA_END,       x2,   src, def, ___) /* va_end(va_list)             */ \
 	_(VA_COPY,      x3,   src, def, def) /* va_copy(dst, stc)           */ \
-	_(VA_ARG,       x2,   src, def, ___) /* va_arg(va_list)             */ \
+	_(VA_ARG,       x2X1, src, def, opt) /* va_arg(va_list)             */ \
+	                                     /* op3 - (size<<3)+log2(align) */ \
 	\
 	/* guards                                                           */ \
 	_(GUARD,        c3,   src, def, def) /* IF without second successor */ \
@@ -583,12 +586,22 @@
 	void *pos;
 } ir_code_buffer;
 
+typedef struct {
+	int   size;
+	int   align;
+	int   offset;
+} ir_value_param;
+
+#define IR_CONST_HASH_SIZE 64
+
 struct _ir_ctx {
 	ir_insn           *ir_base;                 /* two directional array - instructions grow down, constants grow up */
 	ir_ref             insns_count;             /* number of instructions stored in instructions buffer */
 	ir_ref             insns_limit;             /* size of allocated instructions buffer (it's extended when overflow) */
 	ir_ref             consts_count;            /* number of constants stored in constants buffer */
 	ir_ref             consts_limit;            /* size of allocated constants buffer (it's extended when overflow) */
+	uintptr_t          const_hash_mask;
+	ir_ref            *const_hash;
 	uint32_t           flags;                   /* IR context flags (see IR_* defines above) */
 	uint32_t           flags2;                  /* IR context private flags (see IR_* defines in ir_private.h) */
 	ir_type            ret_type;                /* Function return type */
@@ -596,6 +609,7 @@
 	int32_t            status;                  /* non-zero error code (see IR_ERROR_... macros), app may use negative codes */
 	ir_ref             fold_cse_limit;          /* CSE finds identical insns backward from "insn_count" to "fold_cse_limit" */
 	ir_insn            fold_insn;               /* temporary storage for folding engine */
+	ir_value_param    *value_params;            /* information about "by-val" struct parameters */
 	ir_hashtab        *binding;
 	ir_use_list       *use_lists;               /* def->use lists for each instruction */
 	ir_ref            *use_edges;               /* the actual uses: use = ctx->use_edges[ctx->use_lists[def].refs + n] */
@@ -655,7 +669,7 @@
 	ir_loader         *loader;
 	ir_strtab          strtab;
 	ir_ref             prev_insn_chain[IR_LAST_FOLDABLE_OP + 1];
-	ir_ref             prev_const_chain[IR_LAST_TYPE];
+	ir_ref             _const_hash[IR_CONST_HASH_SIZE];
 };
 
 /* Basic IR Construction API (implementation in ir.c) */
@@ -896,6 +910,7 @@
 #define IR_SAVE_SAFE_NAMES (1<<5) /* add '@' prefix to symbol names */
 
 void ir_print_proto(const ir_ctx *ctx, ir_ref proto, FILE *f);
+void ir_print_proto_ex(uint8_t flags, ir_type ret_type, uint32_t params_count, const uint8_t *param_types, FILE *f);
 void ir_save(const ir_ctx *ctx, uint32_t save_flags, FILE *f);
 
 /* IR debug dump API (implementation in ir_dump.c) */
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_ra.c b/ext/opcache/jit/ir/ir_ra.c
--- a/ext/opcache/jit/ir/ir_ra.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_ra.c	2025-10-25 03:24:13.161943616 +0000
@@ -1193,7 +1193,7 @@
 		n = IR_INPUT_EDGES_COUNT(flags);
 		j = 1;
 		p = insn->ops + j;
-		if (flags & IR_OP_FLAG_CONTROL) {
+		if (flags & (IR_OP_FLAG_CONTROL|IR_OP_FLAG_PINNED)) {
 			j++;
 			p++;
 		}
@@ -1340,7 +1340,7 @@
 					  || (ctx->rules[ref] & IR_RULE_MASK) == IR_ALLOCA)
 					 && ctx->use_lists[ref].count > 0) {
 						insn = &ctx->ir_base[ref];
-						if (insn->op != IR_VADDR) {
+						if (insn->op != IR_VADDR && insn->op != IR_PARAM) {
 							insn->op3 = ctx->vars;
 							ctx->vars = ref;
 						}
@@ -1630,6 +1630,10 @@
 	if (ctx->ir_base[IR_LIVE_POS_TO_REF(ctx->live_intervals[r1]->use_pos->pos)].op != IR_VLOAD) {
 		ctx->live_intervals[r1]->flags &= ~IR_LIVE_INTERVAL_MEM_LOAD;
 	}
+	if (ival->flags & IR_LIVE_INTERVAL_MEM_PARAM) {
+		IR_ASSERT(!(ctx->live_intervals[r1]->flags & IR_LIVE_INTERVAL_MEM_PARAM));
+		ctx->live_intervals[r1]->flags |= IR_LIVE_INTERVAL_MEM_PARAM;
+	}
 	ctx->live_intervals[r2] = NULL;
 
 	// TODO: remember to reuse ???
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_save.c b/ext/opcache/jit/ir/ir_save.c
--- a/ext/opcache/jit/ir/ir_save.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_save.c	2025-10-25 03:24:13.162230131 +0000
@@ -10,31 +10,35 @@
 
 void ir_print_proto(const ir_ctx *ctx, ir_ref func_proto, FILE *f)
 {
-	ir_ref j;
-
 	if (func_proto) {
 		const ir_proto_t *proto = (const ir_proto_t *)ir_get_str(ctx, func_proto);
+		ir_print_proto_ex(proto->flags, proto->ret_type, proto->params_count, proto->param_types, f);
+	} else {
+		fprintf(f, "(): int32_t");
+	}
+}
 
-		fprintf(f, "(");
-		if (proto->params_count > 0) {
-			fprintf(f, "%s", ir_type_cname[proto->param_types[0]]);
-			for (j = 1; j < proto->params_count; j++) {
-				fprintf(f, ", %s", ir_type_cname[proto->param_types[j]]);
-			}
-			if (proto->flags & IR_VARARG_FUNC) {
-				fprintf(f, ", ...");
-			}
-		} else if (proto->flags & IR_VARARG_FUNC) {
-			fprintf(f, "...");
+void ir_print_proto_ex(uint8_t flags, ir_type ret_type, uint32_t params_count, const uint8_t *param_types, FILE *f)
+{
+	uint32_t j;
+
+	fprintf(f, "(");
+	if (params_count > 0) {
+		fprintf(f, "%s", ir_type_cname[param_types[0]]);
+		for (j = 1; j < params_count; j++) {
+			fprintf(f, ", %s", ir_type_cname[param_types[j]]);
 		}
-		fprintf(f, "): %s", ir_type_cname[proto->ret_type]);
-		if (proto->flags & IR_FASTCALL_FUNC) {
-			fprintf(f, " __fastcall");
-		} else if (proto->flags & IR_BUILTIN_FUNC) {
-			fprintf(f, " __builtin");
+		if (flags & IR_VARARG_FUNC) {
+			fprintf(f, ", ...");
 		}
-	} else {
-		fprintf(f, "(): int32_t");
+	} else if (flags & IR_VARARG_FUNC) {
+		fprintf(f, "...");
+	}
+	fprintf(f, "): %s", ir_type_cname[ret_type]);
+	if (flags & IR_FASTCALL_FUNC) {
+		fprintf(f, " __fastcall");
+	} else if (flags & IR_BUILTIN_FUNC) {
+		fprintf(f, " __builtin");
 	}
 }
 
@@ -280,6 +284,12 @@
 		}
 		if (first) {
 			fprintf(f, ";");
+		} else if (ctx->value_params
+		 && insn->op == IR_PARAM
+		 && ctx->value_params[insn->op3 - 1].align) {
+			fprintf(f, ") ByVal(%d, %d);",
+				ctx->value_params[insn->op3 - 1].size,
+				ctx->value_params[insn->op3 - 1].align);
 		} else {
 			fprintf(f, ");");
 		}
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_sccp.c b/ext/opcache/jit/ir/ir_sccp.c
--- a/ext/opcache/jit/ir/ir_sccp.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/opcache/jit/ir/ir_sccp.c	2025-10-25 03:24:13.162440675 +0000
@@ -1875,6 +1875,7 @@
 		case IR_I8:
 		case IR_U8:
 		case IR_BOOL:
+		case IR_CHAR:
 			if (op == IR_SEXT) {
 				new_val.i64 = (int64_t)val_insn->val.i8;
 			} else {
@@ -1928,7 +1929,7 @@
 	return ref;
 }
 
-static uint32_t _ir_estimated_control(ir_ctx *ctx, ir_ref val)
+static uint32_t _ir_estimated_control(ir_ctx *ctx, ir_ref val, ir_ref loop)
 {
 	ir_insn *insn;
 	ir_ref n, *p, input, result, ctrl;
@@ -1953,7 +1954,8 @@
 	result = 1;
 	for (; n > 0; p++, n--) {
 		input = *p;
-		ctrl = _ir_estimated_control(ctx, input);
+		ctrl = _ir_estimated_control(ctx, input, loop);
+		if (ctrl >= loop) return ctrl;
 		if (ctrl > result) { // TODO: check dominance depth instead of order
 			result = ctrl;
 		}
@@ -1963,7 +1965,7 @@
 
 static bool ir_is_loop_invariant(ir_ctx *ctx, ir_ref ref, ir_ref loop)
 {
-	ref = _ir_estimated_control(ctx, ref);
+	ref = _ir_estimated_control(ctx, ref, loop);
 	return ref < loop; // TODO: check dominance instead of order
 }
 
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_x86.dasc b/ext/opcache/jit/ir/ir_x86.dasc
